using System;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Collections;

namespace Set
{
	/// <summary>
	/// Summary description for CDeck.
	/// </summary>
	public class CDeck 
	{
		
		private CShape[] m_Shapes;
		private Color[] m_Colors;
		private HatchStyle[] m_Hatches;
		private CCard[] m_Cards;

		private int m_CardCount;
		
		public CDeck()
		{
			m_Cards = new CCard[81];
			m_Colors = new Color[3];
			m_Hatches = new HatchStyle[3];
			m_Shapes = new CShape[3];

			m_CardCount = 0;

			m_Colors[0] = Color.Yellow;
			m_Colors[1] = Color.Blue;
			m_Colors[2] = Color.Green; 

			m_Hatches[0] = HatchStyle.Horizontal;
			m_Hatches[1] = HatchStyle.Plaid;
			m_Hatches[2] = HatchStyle.Percent90;

			m_Shapes[0] = new CSquare();
			m_Shapes[1] = new CCircle();
			m_Shapes[2] = new CTriangle();


			for (int color = 0; color < 3; color++)
			{
				for(int Hatch = 0; Hatch < 3; Hatch++)
				{
					for(int Shape = 0; Shape < 3; Shape++)
					{
						for(int Count = 0; Count < 3; Count++)
						{
							m_Cards[m_CardCount] = new CCard(Count +1,m_Shapes[Shape], m_Hatches[Hatch],m_Colors[color]);
							m_CardCount++;
						}
					}
				}
			}

		}

		public void Suffel()
		{
			const int MAX_CARDS = 81;
			Random r = new Random();

			CCard[] NewCards = new CCard[MAX_CARDS];

			for (int i = 0; i < MAX_CARDS; i++)
			{
				int RandomIndex;

				do
				{
					RandomIndex = r.Next(MAX_CARDS);
				}
				while(NewCards[RandomIndex] != null);

				NewCards[RandomIndex] = m_Cards[i];
			}

			m_Cards = NewCards;
		}

		public CCard Card(int index)
		{
			return m_Cards[index];
		}

		public CCard RemoveNextCard()
		{
			CCard Result = null;
			if (m_CardCount > 0)
			{
				Result = m_Cards[m_CardCount -1];
				m_Cards[m_CardCount -1] = null;
				m_CardCount --;
			}

			return Result;
		}

		public int Count
		{
			get
			{
				return m_CardCount;
			}
		}






















	}
}
