using System;
using System.Collections;

namespace Set
{
	/// <summary>
	/// Summary description for CSet.
	/// </summary>
	public class CSet : System.Collections.CollectionBase
	{

		public CSet()
		{
		}

		public void Add(CCard NewCard)
		{
			if (NewCard != null)
			{
				if (!List.Contains(NewCard))
				{
					List.Add(NewCard);
				}
			}
		}

		public void ClearSet()
		{
			foreach(CCard Card in List)
			{
				Card.Selected = false;
			}

			List.Clear();
		}

		public bool IsASet()
		{
			bool Result = false;


			if (List.Count == 3)
			{
				CCard C1 = (CCard)List[0];
				CCard C2 = (CCard)List[1];
				CCard C3 = (CCard)List[2];
				
				if (C1 != null && C2 != null && C3 != null)
				{
					bool ShapeSet = false;
					bool ColorSet = false;
					bool CountSet = false;
					bool HatchSet = false;

		
					if((C1.Shape == C2.Shape && C2.Shape == C3.Shape) || (C1.Shape != C2.Shape && C1.Shape != C3.Shape && C2.Shape != C3.Shape))
					{
						ShapeSet = true;
					}

					if((C1.Color == C2.Color && C2.Color == C3.Color) || (C1.Color != C2.Color && C1.Color != C3.Color && C2.Color != C3.Color))
					{
						ColorSet = true;
					}

					if((C1.Count == C2.Count && C2.Count == C3.Count) || (C1.Count != C2.Count && C1.Count != C3.Count && C2.Count != C3.Count))
					{
						CountSet = true;
					}

					if((C1.Hatch == C2.Hatch && C2.Hatch == C3.Hatch) || (C1.Hatch != C2.Hatch && C1.Hatch != C3.Hatch && C2.Hatch != C3.Hatch))
					{
						HatchSet = true;
					}
					
					Result =  ShapeSet && ColorSet && CountSet && HatchSet;
				}
			}
			return Result;
		}


		public void Remove(CCard Card)
		{
			List.Remove(Card);
		}
	}
}
