using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Drawing.Drawing2D;

namespace Set
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class frmMain : System.Windows.Forms.Form
	{
		private CCard[] m_CurrentCards;
		private CDeck m_Deck;
		private CSet m_Set;
		private System.Windows.Forms.MainMenu mainMenu1;
		private System.Windows.Forms.MenuItem mnuGame;
		private System.Windows.Forms.MenuItem mnuDeal;
		private System.Windows.Forms.Label lblCardCount;
		private System.Windows.Forms.MenuItem mnuHint;
		private System.Windows.Forms.Label lblPossible;


		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public frmMain()
		{
			
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			m_Deck = new CDeck();
			m_CurrentCards = new CCard[12];
			m_Set = new CSet();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.mainMenu1 = new System.Windows.Forms.MainMenu();
			this.mnuGame = new System.Windows.Forms.MenuItem();
			this.mnuDeal = new System.Windows.Forms.MenuItem();
			this.mnuHint = new System.Windows.Forms.MenuItem();
			this.lblCardCount = new System.Windows.Forms.Label();
			this.lblPossible = new System.Windows.Forms.Label();
			this.SuspendLayout();
			// 
			// mainMenu1
			// 
			this.mainMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.mnuGame});
			// 
			// mnuGame
			// 
			this.mnuGame.Index = 0;
			this.mnuGame.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					this.mnuDeal,
																					this.mnuHint});
			this.mnuGame.Text = "Game";
			// 
			// mnuDeal
			// 
			this.mnuDeal.Index = 0;
			this.mnuDeal.Text = "Deal";
			this.mnuDeal.Click += new System.EventHandler(this.mnuDeal_Click);
			// 
			// mnuHint
			// 
			this.mnuHint.Index = 1;
			this.mnuHint.Text = "Hint";
			this.mnuHint.Click += new System.EventHandler(this.mnuHint_Click);
			// 
			// lblCardCount
			// 
			this.lblCardCount.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.lblCardCount.Font = new System.Drawing.Font("Microsoft Sans Serif", 20F, ((System.Drawing.FontStyle)((System.Drawing.FontStyle.Bold | System.Drawing.FontStyle.Underline))), System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblCardCount.ForeColor = System.Drawing.SystemColors.ActiveCaption;
			this.lblCardCount.Location = new System.Drawing.Point(544, 0);
			this.lblCardCount.Name = "lblCardCount";
			this.lblCardCount.Size = new System.Drawing.Size(48, 56);
			this.lblCardCount.TabIndex = 0;
			this.lblCardCount.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// lblPossible
			// 
			this.lblPossible.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.lblPossible.Font = new System.Drawing.Font("Microsoft Sans Serif", 20F, ((System.Drawing.FontStyle)((System.Drawing.FontStyle.Bold | System.Drawing.FontStyle.Underline))), System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblPossible.ForeColor = System.Drawing.SystemColors.ActiveCaption;
			this.lblPossible.Location = new System.Drawing.Point(544, 56);
			this.lblPossible.Name = "lblPossible";
			this.lblPossible.Size = new System.Drawing.Size(48, 56);
			this.lblPossible.TabIndex = 1;
			this.lblPossible.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// frmMain
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(592, 481);
			this.Controls.Add(this.lblPossible);
			this.Controls.Add(this.lblCardCount);
			this.Menu = this.mainMenu1;
			this.Name = "frmMain";
			this.Text = "Set";
			this.Resize += new System.EventHandler(this.frmMain_Resize);
			this.Load += new System.EventHandler(this.frmMain_Load);
			this.Paint += new System.Windows.Forms.PaintEventHandler(this.frmMain_Paint);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new frmMain());
		}

		private void DisplayCurrentCards()
		{
			int cardIndex = 0;
			
			for(int i = 0; i < 4; i++)
			{
				for(int j = 0; j < 3; j++)
				{
					CCard Card = m_CurrentCards[cardIndex];
					if (Card != null)
					{
						Card.Height = Height/4;
						Card.Width = Width/5;
						Card.Left = Card.Width * i;
						Card.Top = j * Card.Height;
					}

					cardIndex++;
				}
			}
			UpdatePossibleSets();
		}
		

		private void FillCurrentCards()
		{
			int CurrentCardCount = 0;
			for (int i = 0; i < 12; i++)
			{
				if (m_CurrentCards[i] == null)
				{
					m_CurrentCards[i] = m_Deck.RemoveNextCard();
					
					if (m_CurrentCards[i] != null)
					{
						m_CurrentCards[i].CardClicked +=new CardClickedDelegate(CardClicked);
						Controls.Add(m_CurrentCards[i]);
					}
				}

				if (m_CurrentCards[i] != null)
				{
					CurrentCardCount++;
				}
			}

			lblCardCount.Text = Convert.ToString(m_Deck.Count + CurrentCardCount);
		}
		
		private void RemoveCardsFromControlsList()
		{
			for (int i = 0; i < Controls.Count; i++)
			{
				
				if(Controls[i] is CCard)
				{
					Controls.Remove(Controls[i]);
					i--;
				}
			}
		}

		
		private void mnuDeal_Click(object sender, System.EventArgs e)
		{
			RemoveCardsFromControlsList();
			m_CurrentCards = new CCard[12];
			m_Deck = new CDeck();
			m_Set.ClearSet();
			GC.Collect();
			
			m_Deck.Suffel();
				
			FillCurrentCards();
			DisplayCurrentCards();
		
		}

		private void RemoveSetFromCurrentCards()
		{
			foreach (CCard Card in m_Set)
			{
				for(int i = 0; i < m_CurrentCards.Length; i++)
				{
					if (m_CurrentCards[i] == Card)
					{
						Controls.Remove(Card);
						m_CurrentCards[i] = null;
					}
				}
			}
		}

		private void CardClicked(CCard CardClicked)
		{
			if (CardClicked.Selected)
			{
				m_Set.Add(CardClicked);
			}
			else
			{
				m_Set.Remove(CardClicked);
			}

			if (m_Set.Count == 3)
			{
				if (m_Set.IsASet())
				{
					RemoveSetFromCurrentCards();
					m_Set.ClearSet();
					FillCurrentCards();
					DisplayCurrentCards();
				}
				else
				{
					m_Set.ClearSet();
				}
			}
		}

		private void frmMain_Load(object sender, System.EventArgs e)
		{
		
		}

		private void frmMain_Resize(object sender, System.EventArgs e)
		{
			Invalidate();
		}

		private void frmMain_Paint(object sender, System.Windows.Forms.PaintEventArgs e)
		{
			DisplayCurrentCards();
		}

		private void mnuHint_Click(object sender, System.EventArgs e)
		{
			bool FoundSet = false;
			CSet TestSet = new CSet();

			for(int i = 0; !FoundSet && i < 10; i++)
			{
				for(int j = i + 1; !FoundSet && j < 11; j++)
				{
					for(int k = j+1; !FoundSet && k < 12; k++)
					{
						TestSet.ClearSet();
						TestSet.Add(m_CurrentCards[i]);
						TestSet.Add(m_CurrentCards[j]);
						TestSet.Add(m_CurrentCards[k]);

						if(TestSet.IsASet())
						{
							m_CurrentCards[i].BackColor = Color.Plum;
							m_CurrentCards[j].BackColor = Color.Plum;
							m_CurrentCards[k].BackColor = Color.Plum;
							FoundSet = true;
						}
					}
				}
			}
		}

		private void UpdatePossibleSets()
		{
			CSet TestSet = new CSet();

			int SetCount = 0;

			for(int i = 0; i < 10; i++)
			{
				for(int j = i + 1;  j < 11; j++)
				{
					for(int k = j+1;  k < 12; k++)
					{
						TestSet.ClearSet();
						TestSet.Add(m_CurrentCards[i]);
						TestSet.Add(m_CurrentCards[j]);
						TestSet.Add(m_CurrentCards[k]);

						if(TestSet.IsASet())
						{
							SetCount++;
						}
					}
				}
			}
			lblPossible.Text = SetCount.ToString();
		}

	}
}
